## git-annex 3.20120116

=== Makefile ===
PREFIX=/usr
IGNORE=-ignore-package monads-fd
GHCFLAGS=-O2 -Wall $(IGNORE) -fspec-constr-count=8

ifdef PROFILE
GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(IGNORE)
endif

GHCMAKE=ghc $(GHCFLAGS) --make

bins=git-annex git-annex-shell git-union-merge
mans=git-annex.1 git-annex-shell.1 git-union-merge.1
sources=Build/SysConfig.hs Utility/StatFS.hs Utility/Touch.hs

all=$(bins) $(mans) docs

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

all: $(all)

sources: $(sources)

# Disables optimisation. Not for production use.
fast: GHCFLAGS=-Wall $(IGNORE)
fast: $(bins)

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Utility/StatFS.hs
	$(GHCMAKE) configure
	./configure

%.hs: %.hsc
	hsc2hs $<
	perl -i -pe 's/^{-# INCLUDE.*//' $@

$(bins): $(sources)
	$(GHCMAKE) $@

git-annex.1: doc/git-annex.mdwn
	./mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
git-annex-shell.1: doc/git-annex-shell.mdwn
	./mdwn2man git-annex-shell 1 doc/git-annex-shell.mdwn > git-annex-shell.1
git-union-merge.1: doc/git-union-merge.mdwn
	./mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1

install: all
	install -d $(DESTDIR)$(PREFIX)/bin
	install $(bins) $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1
	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
	fi

test:
	@if ! $(GHCMAKE) -O0 test; then \
		echo "** failed to build the test suite" >&2; \
		exit 1; \
	elif ! ./test; then \
		echo "** test suite failed!" >&2; \
		exit 1; \
	fi

testcoverage:
	rm -f test.tix test
	ghc -odir build/test -hidir build/test $(GHCFLAGS) --make -fhpc test
	./test
	@echo ""
	@hpc report test --exclude=Main --exclude=QC
	@hpc markup test --exclude=Main --exclude=QC --destdir=.hpc >/dev/null
	@echo "(See .hpc/ for test coverage details.)"

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

docs: $(mans)
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*'

clean:
	rm -rf build $(bins) $(mans) test configure  *.tix .hpc $(sources)
	rm -rf doc/.ikiwiki html dist
	find . \( -name \*.o -or -name \*.hi \) -exec rm {} \;

# Workaround for cabal sdist not running Setup hooks, so I cannot
# generate a file list there.
sdist: clean
	@if [ ! -e git-annex.cabal.orig ]; then cp git-annex.cabal git-annex.cabal.orig; fi
	@sed -e "s!\(Extra-Source-Files: \).*!\1$(shell find . -name .git -prune -or -not -name \\*.orig -not -type d -print | perl -ne 'print unless length >= 100')!i" < git-annex.cabal.orig > git-annex.cabal
	@cabal sdist
	@mv git-annex.cabal.orig git-annex.cabal

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

.PHONY: $(bins) test install

=== debian/changelog ===
git-annex (3.20120116) unstable; urgency=medium

  * Fix data loss bug in directory special remote, when moving a file
    to the remote failed, and partially transferred content was left
    behind in the directory, re-running the same move would think it
    succeeded and delete the local copy.

 -- Joey Hess <joeyh@debian.org>  Mon, 16 Jan 2012 16:43:45 -0400

git-annex (3.20120115) unstable; urgency=low

  * Add a sanity check for bad StatFS results. On architectures
    where StatFS does not currently work (s390, mips, powerpc, sparc),
    this disables the diskreserve checking code, and attempting to
    configure an annex.diskreserve will result in an error.
  * Fix QuickCheck dependency in cabal file.
  * Minor optimisations.

 -- Joey Hess <joeyh@debian.org>  Sun, 15 Jan 2012 13:54:20 -0400

git-annex (3.20120113) unstable; urgency=low

  * log: Add --gource mode, which generates output usable by gource.
  * map: Fix display of remote repos
  * Add annex-trustlevel configuration settings, which can be used to 
    override the trust level of a remote.
  * git-annex, git-union-merge: Support GIT_DIR and GIT_WORK_TREE.
  * Add libghc-testpack-dev to build depends on all arches.

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Jan 2012 15:35:17 -0400

git-annex (3.20120106) unstable; urgency=low

  * Support unescaped repository urls, like git does.
  * log: New command that displays the location log for files,
    showing each repository they were added to and removed from.
  * Fix overbroad gpg --no-tty fix from last release.

 -- Joey Hess <joeyh@debian.org>  Sat, 07 Jan 2012 13:16:23 -0400

git-annex (3.20120105) unstable; urgency=low

  * Added annex-web-options configuration settings, which can be
    used to provide parameters to whichever of wget or curl git-annex uses
    (depends on which is available, but most of their important options
    suitable for use here are the same).
  * Dotfiles, and files inside dotdirs are not added by "git annex add"
    unless the dotfile or directory is explicitly listed. So "git annex add ."
    will add all untracked files in the current directory except for those in
    dotdirs.
  * Added quickcheck to build dependencies, and fail if test suite cannot be
    built.
  * fsck: Do backend-specific check before checking numcopies is satisfied.
  * Run gpg with --no-tty. Closes: #654721

 -- Joey Hess <joeyh@debian.org>  Thu, 05 Jan 2012 13:44:12 -0400

git-annex (3.20111231) unstable; urgency=low

  * sync: Improved to work well without a central bare repository.
    Thanks to Joachim Breitner.
  * Rather than manually committing, pushing, pulling, merging, and git annex
    merging, we encourage you to give "git annex sync" a try.
  * sync --fast: Selects some of the remotes with the lowest annex.cost
    and syncs those, in addition to any specified at the command line.
  * Union merge now finds the least expensive way to represent the merge.
  * reinject: Add a sanity check for using an annexed file as the source file.
  * Properly handle multiline git config values.
  * Fix the hook special remote, which bitrotted a while ago.
  * map: --fast disables use of dot to display map
  * Test suite improvements. Current top-level test coverage: 75%
  * Improve deletion of files from rsync special remotes. Closes: #652849
  * Add --include, which is the same as --not --exclude.
  * Format strings can be specified using the new --format option, to control
    what is output by git annex find.
  * Support git annex find --json
  * Fixed behavior when multiple insteadOf configs are provided for the
    same url base.
  * Can now be built with older git versions (before 1.7.7); the resulting
    binary should only be used with old git.
  * Updated to build with monad-control 0.3.

 -- Joey Hess <joeyh@debian.org>  Sat, 31 Dec 2011 14:55:29 -0400

=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc,
	libghc-missingh-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-sha-dev,
	libghc-dataenc-dev,
	libghc-http-dev,
	libghc-utf8-string-dev,
	libghc-hs3-dev (>= 0.5.6),
	libghc-testpack-dev,
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-lifted-base-dev,
	libghc-json-dev,
	ikiwiki,
	perlmagick,
	git,
	uuid,
	rsync,
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.9.2
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.7.7),
	uuid,
	rsync,
	wget | curl,
	openssh-client
Suggests: graphviz, bup, gnupg
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, checksumming time, or disk space.
 .
 Even without file content tracking, being able to manage files with git,
 move files around and delete files with versioned directory trees, and use
 branches and distributed clones, are all very handy reasons to use git. And
 annexed files can co-exist in the same git repository with regularly
 versioned files, which is convenient for maintaining documents, Makefiles,
 etc that are associated with annexed files but that benefit from full
 revision control.

## git-annex 3.20120123

=== debian/changelog ===
git-annex (3.20120123) unstable; urgency=low

  * fsck --from: Fscking a remote is now supported. It's done by retrieving
    the contents of the specified files from the remote, and checking them,
    so can be an expensive operation. Still, if the remote is a special
    remote, or a git repository that you cannot run fsck in locally, it's
    nice to have the ability to fsck it.
  * If you have any directory special remotes, now would be a good time to
    fsck them, in case you were hit by the data loss bug fixed in the
    previous release!
  * fsck --from remote --fast: Avoids expensive file transfers, at the
    expense of not checking file size and/or contents.
  * Ssh connection caching is now enabled automatically by git-annex.
    Only one ssh connection is made to each host per git-annex run, which
    can speed some things up a lot, as well as avoiding repeated password
    prompts. Concurrent git-annex processes also share ssh connections.
    Cached ssh connections are shut down when git-annex exits.
  * To disable the ssh caching (if for example you have your own broader
    ssh caching configuration), set annex.sshcaching=false.

 -- Joey Hess <joeyh@debian.org>  Mon, 23 Jan 2012 13:48:48 -0400

## git-annex 3.20120309

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd
-GHCFLAGS=-O2 -Wall $(IGNORE) -fspec-constr-count=8
+GHCFLAGS=-O2 -Wall $(IGNORE)
 
 ifdef PROFILE
 GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(IGNORE)

=== debian/changelog ===
git-annex (3.20120309) unstable; urgency=low

  * Fix key directory hash calculation code to behave as it did before 
    version 3.20120227 when a key contains non-ascii characters (only
    WORM backend is likely to have been affected).

 -- Joey Hess <joeyh@debian.org>  Fri, 09 Mar 2012 20:05:09 -0400

git-annex (3.20120230) unstable; urgency=low

  * "here" can be used to refer to the current repository,
    which can read better than the old "." (which still works too).
  * Directory special remotes now support chunking files written to them,
    avoiding writing files larger than a specified size.
  * Add progress bar display to the directory special remote.
  * Add configurable hooks that are run when git-annex starts and stops
    using a remote: remote.name.annex-start-command and
    remote.name.annex-stop-command
  * Fix a bug in symlink calculation code, that triggered in rare
    cases where an annexed file is in a subdirectory that nearly
    matched to the .git/annex/object/xx/yy subdirectories.

 -- Joey Hess <joeyh@debian.org>  Mon, 05 Mar 2012 13:38:13 -0400

git-annex (3.20120229) unstable; urgency=low

  * Fix test suite to not require a unicode locale.
  * Fix cabal build failure. Thanks, Sergei Trofimovich

 -- Joey Hess <joeyh@debian.org>  Wed, 29 Feb 2012 02:31:31 -0400

git-annex (3.20120227) unstable; urgency=low

  * Modifications to support ghc 7.4's handling of filenames.
    This version can only be built with ghc 7.4 or newer. See the ghc7.0
    branch for older ghcs.
  * S3: Fix irrefutable pattern failure when accessing encrypted S3
    credentials.
  * Use the haskell IfElse library.
  * Fix teardown of stale cached ssh connections.
  * Fixed to use the strict state monad, to avoid leaking all kinds of memory
    due to lazy state update thunks when adding/fixing many files.
  * Fixed some memory leaks that occurred when committing journal files.
  * Added a annex.queuesize setting, useful when adding hundreds of thousands
    of files on a system with plenty of memory.
  * whereis: Prints the urls of files that the web special remote knows about.
  * addurl --fast: Verifies that the url can be downloaded (only getting
    its head), and records the size in the key.
  * When checking that an url has a key, verify that the Content-Length,
    if available, matches the size of the key.
  * addurl: Added a --file option, which can be used to specify what
    file the url is added to. This can be used to override the default
    filename that is used when adding an url, which is based on the url.
    Or, when the file already exists, the url is recorded as another
    location of the file.
  * addurl: Normalize badly encoded urls.
  * addurl: Add --pathdepth option.
  * rekey: New plumbing level command, can be used to change the keys used
    for files en masse.
  * Store web special remote url info in a more efficient location.
    (Urls stored with this version will not be visible to older versions.)
  * Deal with NFS problem that caused a failure to remove a directory
    when removing content from the annex.
  * Make a single location log commit after a remote has received or
    dropped files. Uses a new "git-annex-shell commit" command when available.
  * To avoid commits of data to the git-annex branch after each command
    is run, set annex.alwayscommit=false. Its data will then be committed
    less frequently, when a merge or sync is done.
  * configure: Check if ssh connection caching is supported by the installed
    version of ssh and default annex.sshcaching accordingly.
  * move --from, copy --from: Now 10 times faster when scanning to find
    files in a remote on a local disk; rather than go through the location log
    to see which files are present on the remote, it simply looks at the 
    disk contents directly.

 -- Joey Hess <joeyh@debian.org>  Mon, 27 Feb 2012 12:58:21 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Build-Depends: 
 	debhelper (>= 9),
-	ghc,
+	ghc (>= 7.4),
 	libghc-missingh-dev,
 	libghc-hslogger-dev,
 	libghc-pcre-light-dev,
@@ -17,11 +17,13 @@
 	libghc-monad-control-dev (>= 0.3),
 	libghc-lifted-base-dev,
 	libghc-json-dev,
+	libghc-ifelse-dev,
 	ikiwiki,
 	perlmagick,
 	git,
 	uuid,
 	rsync,
+	openssh-client,
 Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.2
 Vcs-Git: git://git.kitenet.net/git-annex
@@ -35,13 +37,13 @@
 	uuid,
 	rsync,
 	wget | curl,
-	openssh-client
+	openssh-client (>= 1:5.6p1)
 Suggests: graphviz, bup, gnupg
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file
  contents into git. While that may seem paradoxical, it is useful when
  dealing with files larger than git can currently easily handle, whether due
- to limitations in memory, checksumming time, or disk space.
+ to limitations in memory, time, or disk space.
  .
  Even without file content tracking, being able to manage files with git,
  move files around and delete files with versioned directory trees, and use

## git-annex 3.20120315

=== Makefile ===
--- 
+++ 
@@ -1,15 +1,16 @@
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd
-GHCFLAGS=-O2 -Wall $(IGNORE)
+BASEFLAGS=-Wall $(IGNORE) -outputdir tmp
+GHCFLAGS=-O2 $(BASEFLAGS)
 
 ifdef PROFILE
-GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(IGNORE)
+GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(BASEFLAGS)
 endif
 
 GHCMAKE=ghc $(GHCFLAGS) --make
 
-bins=git-annex git-annex-shell git-union-merge
-mans=git-annex.1 git-annex-shell.1 git-union-merge.1
+bins=git-annex
+mans=git-annex.1 git-annex-shell.1
 sources=Build/SysConfig.hs Utility/StatFS.hs Utility/Touch.hs
 
 all=$(bins) $(mans) docs
@@ -24,7 +25,7 @@
 sources: $(sources)
 
 # Disables optimisation. Not for production use.
-fast: GHCFLAGS=-Wall $(IGNORE)
+fast: GHCFLAGS=$(BASEFLAGS)
 fast: $(bins)
 
 Build/SysConfig.hs: configure.hs Build/TestConfig.hs Utility/StatFS.hs
@@ -33,7 +34,6 @@
 
 %.hs: %.hsc
 	hsc2hs $<
-	perl -i -pe 's/^{-# INCLUDE.*//' $@
 
 $(bins): $(sources)
 	$(GHCMAKE) $@
@@ -48,6 +48,7 @@
 install: all
 	install -d $(DESTDIR)$(PREFIX)/bin
 	install $(bins) $(DESTDIR)$(PREFIX)/bin
+	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
 	install -d $(DESTDIR)$(PREFIX)/share/man/man1
 	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1
 	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
@@ -66,7 +67,7 @@
 
 testcoverage:
 	rm -f test.tix test
-	ghc -odir build/test -hidir build/test $(GHCFLAGS) --make -fhpc test
+	ghc $(GHCFLAGS) -outputdir tmp/testcoverage --make -fhpc test
 	./test
 	@echo ""
 	@hpc report test --exclude=Main --exclude=QC
@@ -90,9 +91,8 @@
 		--exclude='news/.*'
 
 clean:
-	rm -rf build $(bins) $(mans) test configure  *.tix .hpc $(sources)
-	rm -rf doc/.ikiwiki html dist
-	find . \( -name \*.o -or -name \*.hi \) -exec rm {} \;
+	rm -rf tmp $(bins) $(mans) test configure  *.tix .hpc $(sources) \
+		doc/.ikiwiki html dist
 
 # Workaround for cabal sdist not running Setup hooks, so I cannot
 # generate a file list there.

=== debian/changelog ===
git-annex (3.20120315) unstable; urgency=low

  * fsck: Fix up any broken links and misplaced content caused by the
    directory hash calculation bug fixed in the last release.
  * sync: Sync to lower cost remotes first.
  * status: Fixed to run in constant space.
  * status: More accurate display of sizes of tmp and bad keys.
  * unused: Now uses a bloom filter, and runs in constant space.
    Use of a bloom filter does mean it will not notice a small
    number of unused keys. For repos with up to half a million keys,
    it will miss one key in 1000.
  * Added annex.bloomcapacity and annex.bloomaccuracy, which can be
    adjusted as desired to tune the bloom filter.
  * status: Display amount of memory used by bloom filter, and
    detect when it's too small for the number of keys in a repository.
  * git-annex-shell: Runs hooks/annex-content after content is received
    or dropped.
  * Work around a bug in rsync (IMHO) introduced by openSUSE's SIP patch.
  * git-annex now behaves as git-annex-shell if symlinked to and run by that
    name. The Makefile sets this up, saving some 8 mb of installed size.
  * git-union-merge is a demo program, so it is no longer built by default.

 -- Joey Hess <joeyh@debian.org>  Thu, 15 Mar 2012 11:05:28 -0400

## git-annex 3.20120406

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd
-BASEFLAGS=-Wall $(IGNORE) -outputdir tmp
+BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility
 GHCFLAGS=-O2 $(BASEFLAGS)
 
 ifdef PROFILE
@@ -11,7 +11,8 @@
 
 bins=git-annex
 mans=git-annex.1 git-annex-shell.1
-sources=Build/SysConfig.hs Utility/StatFS.hs Utility/Touch.hs
+sources=Build/SysConfig.hs Utility/Touch.hs
+clibs=Utility/diskfree.o
 
 all=$(bins) $(mans) docs
 
@@ -28,15 +29,16 @@
 fast: GHCFLAGS=$(BASEFLAGS)
 fast: $(bins)
 
-Build/SysConfig.hs: configure.hs Build/TestConfig.hs Utility/StatFS.hs
+Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
 	$(GHCMAKE) configure
 	./configure
 
 %.hs: %.hsc
 	hsc2hs $<
 
-$(bins): $(sources)
-	$(GHCMAKE) $@
+
+git-annex: $(sources) $(clibs)
+	$(GHCMAKE) $@ $(clibs)
 
 git-annex.1: doc/git-annex.mdwn
 	./mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
@@ -57,7 +59,7 @@
 	fi
 
 test:
-	@if ! $(GHCMAKE) -O0 test; then \
+	@if ! $(GHCMAKE) -O0 test $(clibs); then \
 		echo "** failed to build the test suite" >&2; \
 		exit 1; \
 	elif ! ./test; then \
@@ -92,7 +94,7 @@
 
 clean:
 	rm -rf tmp $(bins) $(mans) test configure  *.tix .hpc $(sources) \
-		doc/.ikiwiki html dist
+		doc/.ikiwiki html dist $(clibs)
 
 # Workaround for cabal sdist not running Setup hooks, so I cannot
 # generate a file list there.

=== debian/changelog ===
git-annex (3.20120406) unstable; urgency=low

  * Disable diskfree on kfreebsd, as I have a build failure on kfreebsd-i386
    that is quite likely caused by it.

 -- Joey Hess <joeyh@debian.org>  Sat, 07 Apr 2012 15:50:36 -0400

git-annex (3.20120405) unstable; urgency=low

  * Rewrote free disk space checking code, moving the portability
    handling into a small C library.
  * status: Display amount of free disk space.

 -- Joey Hess <joeyh@debian.org>  Thu, 05 Apr 2012 16:19:10 -0400

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
 	libghc-lifted-base-dev,
 	libghc-json-dev,
 	libghc-ifelse-dev,
+	libghc-bloomfilter-dev,
 	ikiwiki,
 	perlmagick,
 	git,
@@ -25,7 +26,7 @@
 	rsync,
 	openssh-client,
 Maintainer: Joey Hess <joeyh@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Git: git://git.kitenet.net/git-annex
 Homepage: http://git-annex.branchable.com/

## git-annex 3.20120418

=== debian/changelog ===
git-annex (3.20120418) unstable; urgency=low

  * bugfix: Adding a dotfile also caused all non-dotfiles to be added.
  * bup: Properly handle key names with spaces or other things that are
    not legal git refs.
  * git-annex (but not git-annex-shell) supports the git help.autocorrect
    configuration setting, doing fuzzy matching using the restricted
    Damerau-Levenshtein edit distance, just as git does. This adds a build
    dependency on the haskell edit-distance library.
  * Renamed diskfree.c to avoid OSX case insensativity bug.
  * cabal now installs git-annex-shell as a symlink to git-annex.
  * cabal file now autodetects whether S3 support is available.

 -- Joey Hess <joeyh@debian.org>  Wed, 18 Apr 2012 12:11:32 -0400

## git-annex 3.20120430

=== debian/changelog ===
git-annex (3.20120430) unstable; urgency=low

  * Fix use of annex.diskreserve config setting.
  * Directory special remotes now check annex.diskreserve.
  * Support git's core.sharedRepository configuration.
  * Add annex.http-headers and annex.http-headers-command config
    settings, to allow custom headers to be sent with all HTTP requests.
    (Requested by the Internet Archive)
  * uninit: Clear annex.uuid from .git/config. Closes: #670639
  * Added shared cipher mode to encryptable special remotes. This option
    avoids gpg key distribution, at the expense of flexability, and with
    the requirement that all clones of the git repository be equally trusted.

 -- Joey Hess <joeyh@debian.org>  Mon, 30 Apr 2012 13:16:10 -0400

## git-annex 3.20120511

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd
-BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility
+BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility -DWITH_S3
 GHCFLAGS=-O2 $(BASEFLAGS)
 
 ifdef PROFILE
@@ -12,7 +12,7 @@
 bins=git-annex
 mans=git-annex.1 git-annex-shell.1
 sources=Build/SysConfig.hs Utility/Touch.hs
-clibs=Utility/diskfree.o
+clibs=Utility/libdiskfree.o
 
 all=$(bins) $(mans) docs

=== debian/changelog ===
git-annex (3.20120511) unstable; urgency=low

  * Rsync special remotes can be configured with shellescape=no
    to avoid shell quoting that is normally done when using rsync over ssh.
    This is known to be needed for certian rsync hosting providers
    (specificially hidrive.strato.com) that use rsync over ssh but do not
    pass it through the shell.
  * dropunused: Allow specifying ranges to drop.
  * addunused: New command, the opposite of dropunused, it relinks unused
    content into the git repository.
  * Fix use of several config settings: annex.ssh-options,
    annex.rsync-options, annex.bup-split-options. (And adjust types to avoid
    the bugs that broke several config settings.)

 -- Joey Hess <joeyh@debian.org>  Fri, 11 May 2012 12:29:30 -0400

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,7 @@
 	libghc-json-dev,
 	libghc-ifelse-dev,
 	libghc-bloomfilter-dev,
+	libghc-edit-distance-dev,
 	ikiwiki,
 	perlmagick,
 	git,

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news

## git-annex 3.20120522

=== debian/changelog ===
git-annex (3.20120522) unstable; urgency=low

  * Pass -a to cp even when it supports --reflink=auto, to preserve
    permissions.
  * Clean up handling of git directory and git worktree.
  * Add support for core.worktree, and fix support for GIT_WORK_TREE and
    GIT_DIR.

 -- Joey Hess <joeyh@debian.org>  Tue, 22 May 2012 11:16:13 -0400

## git-annex 3.20120605

=== debian/changelog ===
git-annex (3.20120605) unstable; urgency=low

  * sync: Show a nicer message if a user tries to sync to a special remote.
  * lock: Reset unlocked file to index, rather than to branch head.
  * import: New subcommand, pulls files from a directory outside the annex
    and adds them.
  * Fix display of warning message when encountering a file that uses an
    unsupported backend.
  * Require that the SHA256 backend can be used when building, since it's the
    default.
  * Preserve parent environment when running hooks of the hook special remote.

 -- Joey Hess <joeyh@debian.org>  Tue, 05 Jun 2012 14:03:39 -0400

## git-annex 3.20120611

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PREFIX=/usr
-IGNORE=-ignore-package monads-fd
+IGNORE=-ignore-package monads-fd -ignore-package monads-tf
 BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility -DWITH_S3
 GHCFLAGS=-O2 $(BASEFLAGS)

=== debian/changelog ===
git-annex (3.20120611) unstable; urgency=medium

  * add: Prevent (most) modifications from being made to a file while it
    is being added to the annex.
  * initremote: Automatically describe a remote when creating it.
  * uninit: Refuse to run in a subdirectory. Closes: #677076

 -- Joey Hess <joeyh@debian.org>  Mon, 11 Jun 2012 10:32:01 -0400

## git-annex 3.20120614

=== Makefile ===
--- 
+++ 
@@ -47,18 +47,22 @@
 git-union-merge.1: doc/git-union-merge.mdwn
 	./mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
 
-install: all
-	install -d $(DESTDIR)$(PREFIX)/bin
-	install $(bins) $(DESTDIR)$(PREFIX)/bin
-	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
+install-mans: $(mans)
 	install -d $(DESTDIR)$(PREFIX)/share/man/man1
 	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1
+
+install-docs: docs install-mans
 	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
 	if [ -d html ]; then \
 		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
 	fi
 
-test:
+install: all install-docs
+	install -d $(DESTDIR)$(PREFIX)/bin
+	install $(bins) $(DESTDIR)$(PREFIX)/bin
+	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
+
+test: $(sources) $(clibs)
 	@if ! $(GHCMAKE) -O0 test $(clibs); then \
 		echo "** failed to build the test suite" >&2; \
 		exit 1; \
@@ -96,13 +100,10 @@
 	rm -rf tmp $(bins) $(mans) test configure  *.tix .hpc $(sources) \
 		doc/.ikiwiki html dist $(clibs)
 
-# Workaround for cabal sdist not running Setup hooks, so I cannot
-# generate a file list there.
-sdist: clean
-	@if [ ! -e git-annex.cabal.orig ]; then cp git-annex.cabal git-annex.cabal.orig; fi
-	@sed -e "s!\(Extra-Source-Files: \).*!\1$(shell find . -name .git -prune -or -not -name \\*.orig -not -type d -print | perl -ne 'print unless length >= 100')!i" < git-annex.cabal.orig > git-annex.cabal
-	@cabal sdist
-	@mv git-annex.cabal.orig git-annex.cabal
+# Workaround for `cabal sdist` requiring all included files to be listed
+# in .cabal.
+sdist: clean $(mans)
+	./make-sdist.sh
 
 # Upload to hackage.
 hackage: sdist

=== debian/changelog ===
git-annex (3.20120614) unstable; urgency=medium

  * addurl: Was broken by a typo introduced 2 released ago, now fixed.
    Closes: #677576
  * Install man page when run by cabal, in a location where man will
    find it, even when installing under $HOME. Thanks, Nathan Collins

 -- Joey Hess <joeyh@debian.org>  Thu, 14 Jun 2012 20:21:29 -0400

## git-annex 3.20120624

=== Makefile ===
--- 
+++ 
@@ -1,20 +1,28 @@
+bins=git-annex
+mans=git-annex.1 git-annex-shell.1
+sources=Build/SysConfig.hs Utility/Touch.hs
+all=$(bins) $(mans) docs
+
+OS:=$(shell uname | sed 's/[-_].*//')
+ifeq ($(OS),Linux)
+BASEFLAGS_OPTS+=-DWITH_INOTIFY
+clibs=Utility/libdiskfree.o
+else
+BASEFLAGS_OPTS+=-DWITH_KQUEUE
+clibs=Utility/libdiskfree.o Utility/libkqueue.o
+endif
+
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd -ignore-package monads-tf
-BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility -DWITH_S3
+BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility -DWITH_S3 $(BASEFLAGS_OPTS)
 GHCFLAGS=-O2 $(BASEFLAGS)
+CFLAGS=-Wall
 
 ifdef PROFILE
 GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(BASEFLAGS)
 endif
 
 GHCMAKE=ghc $(GHCFLAGS) --make
-
-bins=git-annex
-mans=git-annex.1 git-annex-shell.1
-sources=Build/SysConfig.hs Utility/Touch.hs
-clibs=Utility/libdiskfree.o
-
-all=$(bins) $(mans) docs
 
 # Am I typing :make in vim? Do a fast build.
 ifdef VIM
@@ -100,8 +108,6 @@
 	rm -rf tmp $(bins) $(mans) test configure  *.tix .hpc $(sources) \
 		doc/.ikiwiki html dist $(clibs)
 
-# Workaround for `cabal sdist` requiring all included files to be listed
-# in .cabal.
 sdist: clean $(mans)
 	./make-sdist.sh

=== debian/changelog ===
git-annex (3.20120624) unstable; urgency=low

  * watch: New subcommand, a daemon which notices changes to
    files and automatically annexes new files, etc, so you don't
    need to manually run git commands when manipulating files.
    Available on Linux, BSDs, and OSX!
  * Enable diskfree on kfreebsd, using kqueue.
  * unused: Fix crash when key names contain invalid utf8.
  * sync: Avoid recent git's interactive merge.

 -- Joey Hess <joeyh@debian.org>  Sun, 24 Jun 2012 12:36:50 -0400

=== debian/control ===
--- 
+++ 
@@ -20,6 +20,8 @@
 	libghc-ifelse-dev,
 	libghc-bloomfilter-dev,
 	libghc-edit-distance-dev,
+	libghc-hinotify-dev [linux-any],
+	libghc-stm-dev,
 	ikiwiki,
 	perlmagick,
 	git,
@@ -40,6 +42,7 @@
 	rsync,
 	wget | curl,
 	openssh-client (>= 1:5.6p1)
+Recommends: lsof
 Suggests: graphviz, bup, gnupg
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file

## git-annex 3.20120629~bpo60+2

=== Makefile ===
--- 
+++ 
@@ -5,16 +5,16 @@
 
 OS:=$(shell uname | sed 's/[-_].*//')
 ifeq ($(OS),Linux)
-BASEFLAGS_OPTS+=-DWITH_INOTIFY
+#BASEFLAGS_OPTS+=-DWITH_INOTIFY
 clibs=Utility/libdiskfree.o
 else
-BASEFLAGS_OPTS+=-DWITH_KQUEUE
+#BASEFLAGS_OPTS+=-DWITH_KQUEUE
 clibs=Utility/libdiskfree.o Utility/libkqueue.o
 endif
 
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd -ignore-package monads-tf
-BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility -DWITH_S3 $(BASEFLAGS_OPTS)
+BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility $(BASEFLAGS_OPTS)
 GHCFLAGS=-O2 $(BASEFLAGS)
 CFLAGS=-Wall

=== debian/changelog ===
git-annex (3.20120629~bpo60+2) squeeze-backports; urgency=low

  * Avoid passing --no-edit to git merge when the version of git doesn't
    support it.

 -- Joey Hess <joeyh@debian.org>  Fri, 21 Sep 2012 23:30:38 -0400

git-annex (3.20120629~bpo60+1) squeeze-backports; urgency=low

  * cabal: Only try to use inotify on Linux.
  * Version build dependency on STM, and allow building without it,
    which disables the watch command.
  * Note: watch command is disabled in this backport.
  * Avoid ugly failure mode when moving content from a local repository
    that is not available.
  * Got rid of the last place that did utf8 decoding.
  * Accept arbitrarily encoded repository filepaths etc when reading
    git config output. This fixes support for remotes with unusual characters
    in their names.
  * sync: Automatically resolves merge conflicts.

 -- Joey Hess <joeyh@debian.org>  Tue, 24 Jul 2012 15:44:00 +0000

git-annex (3.20120614~bpo60+1) squeeze-backports; urgency=medium

  * addurl: Was broken by a typo introduced 2 released ago, now fixed.
    Closes: #677576
  * Install man page when run by cabal, in a location where man will
    find it, even when installing under $HOME. Thanks, Nathan Collins

 -- Joey Hess <joeyh@debian.org>  Sun, 24 Jun 2012 12:56:42 -0400

git-annex (3.20120522~bpo60+1) squeeze-backports; urgency=low

  * Pass -a to cp even when it supports --reflink=auto, to preserve
    permissions.
  * Clean up handling of git directory and git worktree.
  * Add support for core.worktree, and fix support for GIT_WORK_TREE and
    GIT_DIR.

 -- Joey Hess <joeyh@debian.org>  Tue, 22 May 2012 11:16:13 -0400

git-annex (3.20120511~bpo60+1) squeeze-backports; urgency=low

  * Rsync special remotes can be configured with shellescape=no
    to avoid shell quoting that is normally done when using rsync over ssh.
    This is known to be needed for certian rsync hosting providers
    (specificially hidrive.strato.com) that use rsync over ssh but do not
    pass it through the shell.
  * dropunused: Allow specifying ranges to drop.
  * addunused: New command, the opposite of dropunused, it relinks unused
    content into the git repository.
  * Fix use of several config settings: annex.ssh-options,
    annex.rsync-options, annex.bup-split-options. (And adjust types to avoid
    the bugs that broke several config settings.)

 -- Joey Hess <joeyh@debian.org>  Fri, 11 May 2012 12:29:30 -0400

git-annex (3.20120430~bpo60+1) squeeze-backports; urgency=low

  * Fix use of annex.diskreserve config setting.
  * Directory special remotes now check annex.diskreserve.
  * Support git's core.sharedRepository configuration.
  * Add annex.http-headers and annex.http-headers-command config
    settings, to allow custom headers to be sent with all HTTP requests.
    (Requested by the Internet Archive)
  * uninit: Clear annex.uuid from .git/config. Closes: #670639
  * Added shared cipher mode to encryptable special remotes. This option
    avoids gpg key distribution, at the expense of flexability, and with
    the requirement that all clones of the git repository be equally trusted.

 -- Joey Hess <joeyh@debian.org>  Mon, 14 May 2012 13:13:47 -0400

git-annex (3.20120418~bpo60+1) squeeze-backports; urgency=low

  * bugfix: Adding a dotfile also caused all non-dotfiles to be added.
  * bup: Properly handle key names with spaces or other things that are
    not legal git refs.
  * git-annex (but not git-annex-shell) supports the git help.autocorrect
    configuration setting, doing fuzzy matching using the restricted
    Damerau-Levenshtein edit distance, just as git does. This adds a build
    dependency on the haskell edit-distance library.
  * Renamed diskfree.c to avoid OSX case insensativity bug.
  * cabal now installs git-annex-shell as a symlink to git-annex.
  * cabal file now autodetects whether S3 support is available.
  * Disabled bloom filter and edit-distance code for backport.
  * Avoid checking git version too often.

 -- Joey Hess <joeyh@debian.org>  Sun, 29 Apr 2012 15:41:24 -0400

git-annex (3.20120123~bpo60+4) squeeze-backports; urgency=low

  * Fix a bug in symlink calculation code, that triggered in rare
    cases where an annexed file is in a subdirectory that nearly
    matched to the .git/annex/object/xx/yy subdirectories.

 -- Joey Hess <joeyh@debian.org>  Mon, 05 Mar 2012 13:52:22 -0400

git-annex (3.20120123~bpo60+3) squeeze-backports; urgency=low

  * configure: Check if ssh connection caching is supported by the installed
    version of ssh and default annex.sshcaching accordingly.

 -- Joey Hess <joeyh@debian.org>  Sat, 25 Feb 2012 19:20:06 -0400

git-annex (3.20120123~bpo60+2) squeeze-backports; urgency=low

  * Fix runtime git version detection code. Closes: #660646

 -- Joey Hess <joeyh@debian.org>  Mon, 20 Feb 2012 13:37:09 -0400

git-annex (3.20120123~bpo60+1) squeeze-backports; urgency=low

  * Fixed build dependency that made the previous backport FTBFS on several
    architectures.
  * fsck --from: Fscking a remote is now supported. It's done by retrieving
    the contents of the specified files from the remote, and checking them,
    so can be an expensive operation. Still, if the remote is a special
    remote, or a git repository that you cannot run fsck in locally, it's
    nice to have the ability to fsck it.
  * If you have any directory special remotes, now would be a good time to
    fsck them, in case you were hit by the data loss bug fixed in the
    previous release!
  * fsck --from remote --fast: Avoids expensive file transfers, at the
    expense of not checking file size and/or contents.
  * Ssh connection caching is now enabled automatically by git-annex.
    Only one ssh connection is made to each host per git-annex run, which
    can speed some things up a lot, as well as avoiding repeated password
    prompts. Concurrent git-annex processes also share ssh connections.
    Cached ssh connections are shut down when git-annex exits.


=== debian/control ===
--- 
+++ 
@@ -2,26 +2,18 @@
 Section: utils
 Priority: optional
 Build-Depends: 
-	debhelper (>= 9),
-	ghc (>= 7.4),
-	libghc-missingh-dev,
-	libghc-hslogger-dev,
-	libghc-pcre-light-dev,
-	libghc-sha-dev,
-	libghc-dataenc-dev,
-	libghc-http-dev,
-	libghc-utf8-string-dev,
-	libghc-hs3-dev (>= 0.5.6),
-	libghc-testpack-dev,
-	libghc-quickcheck2-dev,
-	libghc-monad-control-dev (>= 0.3),
-	libghc-lifted-base-dev,
-	libghc-json-dev,
-	libghc-ifelse-dev,
-	libghc-bloomfilter-dev,
-	libghc-edit-distance-dev,
-	libghc-hinotify-dev [linux-any],
-	libghc-stm-dev,
+	debhelper (>= 8),
+	ghc,
+	libghc6-missingh-dev,
+	libghc6-hslogger-dev,
+	libghc6-pcre-light-dev,
+	libghc6-sha-dev,
+	libghc6-dataenc-dev,
+	libghc6-http-dev,
+	libghc6-utf8-string-dev,
+	libghc6-testpack-dev,
+	libghc6-json-dev,
+	libghc6-quickcheck2-dev,
 	ikiwiki,
 	perlmagick,
 	git,
@@ -37,11 +29,11 @@
 Architecture: any
 Section: utils
 Depends: ${misc:Depends}, ${shlibs:Depends},
-	git (>= 1:1.7.7),
+	git | git-core,
 	uuid,
 	rsync,
 	wget | curl,
-	openssh-client (>= 1:5.6p1)
+	openssh-client
 Recommends: lsof
 Suggests: graphviz, bup, gnupg
 Description: manage files with git, without checking their contents into git

## git-annex 3.20120629

=== debian/changelog ===
git-annex (3.20120629) unstable; urgency=low

  * cabal: Only try to use inotify on Linux.
  * Version build dependency on STM, and allow building without it,
    which disables the watch command.
  * Avoid ugly failure mode when moving content from a local repository
    that is not available.
  * Got rid of the last place that did utf8 decoding.
  * Accept arbitrarily encoded repository filepaths etc when reading
    git config output. This fixes support for remotes with unusual characters
    in their names.
  * sync: Automatically resolves merge conflicts.

 -- Joey Hess <joeyh@debian.org>  Fri, 29 Jun 2012 10:17:49 -0400

## git-annex 3.20120629+deb7u1

=== Makefile ===
--- 
+++ 
@@ -5,16 +5,16 @@
 
 OS:=$(shell uname | sed 's/[-_].*//')
 ifeq ($(OS),Linux)
-#BASEFLAGS_OPTS+=-DWITH_INOTIFY
+BASEFLAGS_OPTS+=-DWITH_INOTIFY
 clibs=Utility/libdiskfree.o
 else
-#BASEFLAGS_OPTS+=-DWITH_KQUEUE
+BASEFLAGS_OPTS+=-DWITH_KQUEUE
 clibs=Utility/libdiskfree.o Utility/libkqueue.o
 endif
 
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd -ignore-package monads-tf
-BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility $(BASEFLAGS_OPTS)
+BASEFLAGS=-Wall $(IGNORE) -outputdir tmp -IUtility -DWITH_ASSISTANT -DWITH_S3 $(BASEFLAGS_OPTS)
 GHCFLAGS=-O2 $(BASEFLAGS)
 CFLAGS=-Wall

=== debian/changelog ===
git-annex (3.20120629+deb7u1) wheezy-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2017-12976: git-annex before 6.20170818 allows remote attackers to
    execute arbitrary commands via an ssh URL with an initial dash
    character in the hostname, as demonstrated by an ssh://-eProxyCommand=
    URL (Closes: #873088)

 -- Antoine Beaupre <anarcat@debian.org>  Thu, 26 Oct 2017 09:30:00 -0400

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,26 @@
 Section: utils
 Priority: optional
 Build-Depends: 
-	debhelper (>= 8),
-	ghc,
-	libghc6-missingh-dev,
-	libghc6-hslogger-dev,
-	libghc6-pcre-light-dev,
-	libghc6-sha-dev,
-	libghc6-dataenc-dev,
-	libghc6-http-dev,
-	libghc6-utf8-string-dev,
-	libghc6-testpack-dev,
-	libghc6-json-dev,
-	libghc6-quickcheck2-dev,
+	debhelper (>= 9),
+	ghc (>= 7.4),
+	libghc-missingh-dev,
+	libghc-hslogger-dev,
+	libghc-pcre-light-dev,
+	libghc-sha-dev,
+	libghc-dataenc-dev,
+	libghc-http-dev,
+	libghc-utf8-string-dev,
+	libghc-hs3-dev (>= 0.5.6),
+	libghc-testpack-dev,
+	libghc-quickcheck2-dev,
+	libghc-monad-control-dev (>= 0.3),
+	libghc-lifted-base-dev,
+	libghc-json-dev,
+	libghc-ifelse-dev,
+	libghc-bloomfilter-dev,
+	libghc-edit-distance-dev,
+	libghc-hinotify-dev [linux-any],
+	libghc-stm-dev (>= 2.3),
 	ikiwiki,
 	perlmagick,
 	git,
@@ -29,11 +37,11 @@
 Architecture: any
 Section: utils
 Depends: ${misc:Depends}, ${shlibs:Depends},
-	git | git-core,
+	git (>= 1:1.7.7),
 	uuid,
 	rsync,
 	wget | curl,
-	openssh-client
+	openssh-client (>= 1:5.6p1)
 Recommends: lsof
 Suggests: graphviz, bup, gnupg
 Description: manage files with git, without checking their contents into git
